'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const cheerio = require('cheerio');
const got = require('got');
const url = "http://sarki.alternatifim.com";

const decode = (() => {
  var _ref = _asyncToGenerator(function* (url) {
    let { body } = yield got(url, { encoding: null });
    return body;
  });

  return function decode(_x) {
    return _ref.apply(this, arguments);
  };
})();

const getPages = (() => {
  var _ref2 = _asyncToGenerator(function* (body) {

    const regex = /max_page : ([^']+),/g;

    let text = regex.exec(body);

    if (text != null) {
      let max_page = parseInt(text[1]);
      return max_page;
    } else {
      return null;
    }
  });

  return function getPages(_x2) {
    return _ref2.apply(this, arguments);
  };
})();

const getList = (() => {
  var _ref3 = _asyncToGenerator(function* (body) {

    var $ = cheerio.load(body, { decodeEntities: false });
    var block = $('.sarkisozu').html();
    var $$ = cheerio.load(block, { decodeEntities: false });

    var list = $$('ul li').map(function (i) {

      let path = $$(this).find('a').attr('href');
      let name = $$(this).find('a').text().replace('&nbsp;', '').replace('&nbsp;', '');
      return {
        name,
        path
      };
    }).get();

    return list;
  });

  return function getList(_x3) {
    return _ref3.apply(this, arguments);
  };
})();

const search = (() => {
  var _ref4 = _asyncToGenerator(function* (options = {}) {

    var uri = `${url}/listele.asp?`;
    let path = null;
    let list = [];
    let params = Object.assign({ artist: null, song: null }, options);

    if (params.artist && params.song) {
      path = `fsarkici=${escape(params.artist)}&fsarki=${escape(params.song)}`;
    } else if (!params.song) {
      path = `fsarkici=${escape(params.artist)}`;
    }

    let response = yield decode(`${uri}${path}`);
    let pages = yield getPages(response);

    if (pages != null) {

      for (let page = 1; page < pages + 1; page++) {
        let body = yield decode(`${uri}${path}&page=${page}`);
        let data = yield getList(body);
        list = [...list, ...data];
      }
    } else {
      let data = yield getList(response);
      list = [...list, ...data];
    }

    return list;
  });

  return function search() {
    return _ref4.apply(this, arguments);
  };
})();

const show = (() => {
  var _ref5 = _asyncToGenerator(function* (path) {
    let response = yield decode(`${url}${path}`);
    const lyric = {};
    const $ = cheerio.load(response, { decodeEntities: false });
    lyric.title = $('h1.baslik').text();
    lyric.content = $('.sarkisozu').text().replace('[ reklamı gizle / hide ads ]', '').replace('report this ad', '');

    return lyric;
  });

  return function show(_x4) {
    return _ref5.apply(this, arguments);
  };
})();

exports.search = search;
exports.show = show;